<?php
/**
 * HTML Fabrik List view class
 *
 * @package     Joomla
 * @subpackage  Fabrik
 * @copyright   Copyright (C) 2005-2013 fabrikar.com - All rights reserved.
 * @license     GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

// No direct access
defined('_JEXEC') or die('Restricted access');

require_once JPATH_SITE . '/components/com_fabrik/views/list/view.base.php';

/**
 * HTML Fabrik List view class
 *
 * @package     Joomla
 * @subpackage  Fabrik
 * @since       3.0
 */

class FabrikViewList extends FabrikViewListBase
{
	/**
	 * Display the template
	 *
	 * @param   sting  $tpl  template
	 *
	 * @return void
	 */

	public function display($tpl = null)
	{
		if (parent::display($tpl) !== false)
		{
			$model = $this->getModel();
			$this->tabs = $model->loadTabs();
			$app = JFactory::getApplication();

			if (!$app->isAdmin() && isset($this->params))
			{
				$this->state = $this->get('State');
				$stateparams = $this->state->get('params');
				$this->document = JFactory::getDocument();

				if ($stateparams->get('menu-meta_description'))
				{
					$this->document->setDescription($stateparams->get('menu-meta_description'));
				}

				if ($stateparams->get('menu-meta_keywords'))
				{
					$this->document->setMetadata('keywords', $stateparams->get('menu-meta_keywords'));
				}

				if ($stateparams->get('robots'))
				{
					$this->document->setMetadata('robots', $stateparams->get('robots'));
				}
			}

			$this->output();
		}
	}
}
